#include "stdafx.h"


extern FILE* log;


HttpClient::HttpClient()
{
	hSession = hFile = NULL;
	bufferSize = 0;
}

HttpClient::~HttpClient()
{	
	if (hSession != NULL)
	{
		InternetCloseHandle(hSession);
	}
}

bool HttpClient::combineUrl(URL_COMPONENTS& url, LPCTSTR link, LPTSTR buffer, int bufSize)
{
	int offset =0;
	int bufOffset = 0;
	int i, j;
	TCHAR temp[64];

	//_tprintf(_T("link=[%s]\n"), link);
	offset = findFirstStringW(link, _tcslen(link), _T("://"));
	if (offset < 0)
	{
		_sntprintf(buffer+bufOffset, url.dwSchemeLength, _T("%s"), url.lpszScheme);
		bufOffset += url.dwSchemeLength;
		_sntprintf(buffer+bufOffset, 3, _T("://"));
		bufOffset += 3;
		for (i = url.dwHostNameLength; i>= 0; i--)
		{
			if (url.lpszHostName[i] !=_T(' '))
			{
				break;
			}
		}
		_tcsncpy(buffer + bufOffset, url.lpszHostName, i);
		bufOffset += url.dwHostNameLength;
		buffer[bufOffset]= '\0';
		//_tprintf(_T("[%s]\n"), buffer);
		j = skipSpaceW(link, _tcslen(link));

		strncpy((char*)temp, (char*)url.lpszHostName, url.dwHostNameLength);
		temp[url.dwHostNameLength]='\0';
		//printf("[%s]\n", (char*)temp);

		bufOffset += i + 1;
		if (url.lpszHostName[i] != _T('/'))
		{				
			if (link[j] != _T('/'))
			{
				buffer[bufOffset] = _T('/');
				bufOffset++;
				_tcscpy(buffer+ bufOffset, link + j);
			}
			else
			{
				_tcscpy(buffer+ bufOffset, link + j);
			}
			bufOffset += _tcslen(link) - j;
			//_tprintf(_T("[%s]\n"), buffer);
		}
		else
		{

			if (link[j] == _T('/'))
			{
				_tcscpy(buffer+bufOffset , link+j+1);
				bufOffset += _tcslen(link) - j -1;

			}
			else
			{
				_tcscpy(buffer+bufOffset , link+j);
				bufOffset += _tcslen(link) - j;	 
			}
			//_tprintf(_T("[%s]\n"), buffer);
		}
		buffer[bufOffset] = _T('\0');
		//_tprintf(_T("[%s]\n"), buffer);
	}
	else
	{
		_tcscpy(buffer, link);
	}
	return true;
}

bool HttpClient::doDownloadImage()
{
	DomainNameType theName;

	while (!htmlParser.nameQueue.empty())
	{
		theName = htmlParser.nameQueue.front();
		_tprintf(_T("picture link[%s] is about to be read\n"), theName.nameBuffer);
		_ftprintf(log, _T("picture link[%s] is about to be read\n"), theName.nameBuffer);

	
		if (readWebSite(theName.nameBuffer, 1))
		{
			savePictureFile((LPBYTE)buffer, bufferSize, log); 
			break;
		}  	
		htmlParser.nameQueue.pop_front();
	}
	return true;
}


int HttpClient::searchWebSite(LPCTSTR www)
{
	extern int saveCounter;
	int searchCounter = 0;
	int imageCounter = 0;
	//TCHAR hostName[MaxDomainNameLength];
	//TCHAR schemeBuf[MaxDomainNameLength];
	DomainNameType theLink, theName;
	if ((log = fopen("httpclient.log", "a"))== NULL)
	{
		_tprintf(_T("cannot open log\n"));
		return -1;
	}
	_stprintf(theLink.nameBuffer, _T("%s"), www);
	htmlParser.linkSet.clear();
	htmlParser.linkSet.insert(theLink);

	if (readWebSite(www))
	{
		htmlParser.retrieveCurrentHost(www, htmlParser.currentHost, 
			htmlParser.currentHostNameLength);
		_ftprintf(log, _T("the host name is [%s]\n"), htmlParser.currentHost.nameBuffer);
		htmlParser.parseBuffer(www, (LPTSTR)buffer, bufferSize, log);
	}
	while (!htmlParser.linkQueue.empty() && htmlParser.linkQueue.size()<10000 
		&& htmlParser.nameQueue.size()<50000 && searchCounter < 100000)
	{
		theLink = htmlParser.linkQueue.front();			
		
		_tprintf(_T("the link[%s] is going to be read\n"), theLink.nameBuffer);
		_ftprintf(log, _T("the link[%s] is going to be read\n"), theLink.nameBuffer);
		
		if (!htmlParser.isOutsideHostName(theLink.nameBuffer))
		{
			if (readWebSite(theLink.nameBuffer, 1))
			{
				searchCounter ++; 				
				_ftprintf(log, _T("************link[%s] will be parsed********\n"), theLink.nameBuffer);
				_tprintf(_T("*************link[%s] will be parsed*************\n"), theLink.nameBuffer);
				if (!htmlParser.parseBuffer(theLink.nameBuffer, (LPTSTR)buffer, bufferSize, log))
				{
					imageCounter++;
				}
				//doDownloadImage();
			}
		}
		else
		{
			_tprintf(_T("outside host [%s]\n"), theLink.nameBuffer);
			_ftprintf(log, _T("link[%s] is outside [%s]\n"), theLink.nameBuffer, www);
		} 	

		htmlParser.linkQueue.pop_front();	
	}
	imageCounter = htmlParser.nameQueue.size();
	doDownloadImage();
	
	
	printf("total link count[%d], total image[%d] total save count [%d]\n", 
		searchCounter, imageCounter, saveCounter);
	fprintf(log, "total link count[%d], total image[%d] total save count [%d]\n", 
		searchCounter, imageCounter, saveCounter);
	fclose(log);
	return saveCounter;
}

bool HttpClient::readWebSite(LPCTSTR www, int trialNumber)
{
	int trial = 0;
	while (trial < trialNumber)
	{
		if (readWebSite(www))
		{
			return true;
		}
		trial ++;
	}
	return false;
}





/////////////////////////////////////////////////////////////////////////////////////////////
bool HttpClient::readWebSite(LPCTSTR www)
{   
	DWORD size = -1;
	int offset = 0;
	bool result = false;
  	_tprintf(_T("\nread website[www]=[%s]\n"), www);
	_ftprintf(log, _T("\nread website[www]=[%s]\n"), www);

	if ((hSession = InternetOpen(_T("Microsoft Internet Explorer"), INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, INTERNET_INVALID_PORT_NUMBER)) 
			  == NULL)
	{
		return false;
	}  	

	if ((hFile = InternetOpenUrl(hSession, www, NULL, 0, INTERNET_FLAG_DONT_CACHE, NULL))!= NULL)
	{  			
		while (InternetReadFile(hFile, buffer + offset, BufferSize, &size))
		{
			if (size == 0)
			{
				bufferSize = offset;
				result = true;
			    break;
			}
			offset += size;
			if (offset > BufferSize)
			{
				printf("************************buffer overflow!***************************\n");
				result = false;
				break;
			}
		}  
		if (size != 0)
		{
			_tprintf(_T("read web page [%s] error!!!!!!!!!!!!!\n"), www);
			_ftprintf(log, _T("read web page [%s] error!!!!!!!!!!!!!\n"), www);
			result= false;
		}
		if (InternetCloseHandle(hFile))
		{
			hFile = NULL;
		}
		else
		{
			printf("error of close handle\n");
			result = false;
		}
	}
	else
	{
		printf("\n\n%d\n\n", GetLastError());
	}
	if (InternetCloseHandle(hSession))
	{
		hFile = NULL;
	}

    return result;
}



/*
	memset(&url_comp, 0, sizeof(URL_COMPONENTS));
		url_comp.dwStructSize = sizeof(URL_COMPONENTS);
		//url_comp.dwHostNameLength = 1;// url_comp.dwExtraInfoLength = url_comp.dwPasswordLength=
			//url_comp.dwSchemeLength=url_comp.dwUrlPathLength=url_comp.dwUserNameLength = 1;
		url_comp.dwSchemeLength= MaxDomainNameLength;
		url_comp.dwSchemeLength = MaxDomainNameLength;
		url_comp.lpszHostName = hostName;
		url_comp.lpszScheme = schemeBuf;
		
		if (!InternetCrackUrl(www, _tcslen(www), ICU_DECODE , &url_comp))
		{
			printf("error %d\n", GetLastError());
		}  

		//hostName[url_comp.dwHostNameLength] = _T('\0');
		//schemeBuf[url_comp.dwSchemeLength] = _T('\0');

		//_tprintf(_T("[%s][%s]\n"), hostName, schemeBuf);
		for (i =0; i< url_comp.dwHostNameLength; i++)
		{
			_tprintf(_T("%c"), hostName[i]);
		}

		for (i =0; i< url_comp.dwSchemeLength; i++)
		{
			_tprintf(_T("%c"), schemeBuf[i]);
		}

  */